// Code generated by go-swagger; DO NOT EDIT.

package auth

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// AuthExchangeHandlerFunc turns a function with the right signature into a auth exchange handler
type AuthExchangeHandlerFunc func(AuthExchangeParams) middleware.Responder

// Handle executing the request and returning a response
func (fn AuthExchangeHandlerFunc) Handle(params AuthExchangeParams) middleware.Responder {
	return fn(params)
}

// AuthExchangeHandler interface for that can handle valid auth exchange params
type AuthExchangeHandler interface {
	Handle(AuthExchangeParams) middleware.Responder
}

// NewAuthExchange creates a new http.Handler for the auth exchange operation
func NewAuthExchange(ctx *middleware.Context, handler AuthExchangeHandler) *AuthExchange {
	return &AuthExchange{Context: ctx, Handler: handler}
}

/*AuthExchange swagger:route POST /api/auth/exchange Auth authExchange

User exchange refresh token to access

*/
type AuthExchange struct {
	Context *middleware.Context
	Handler AuthExchangeHandler
}

func (o *AuthExchange) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewAuthExchangeParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
